/************************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

********************************************************/

/* $XConsortium: globals.c,v 1.47 89/12/07 20:33:48 keith Exp $ */

#include "X.h"
#include "Xmd.h"
#include "misc.h"
#include "windowstr.h"
#include "scrnintstr.h"
#include "input.h"
#include "dixfont.h"
#include "site.h"
#include "dixstruct.h"
#include "os.h"

ScreenInfo _near screenInfo;
KeybdCtrl _near defaultKeyboardControl = {
	DEFAULT_KEYBOARD_CLICK,
	DEFAULT_BELL,
	DEFAULT_BELL_PITCH,
	DEFAULT_BELL_DURATION,
	DEFAULT_AUTOREPEAT,
	DEFAULT_AUTOREPEATS,
	DEFAULT_LEDS};

PtrCtrl _near defaultPointerControl = {
	DEFAULT_PTR_NUMERATOR,
	DEFAULT_PTR_DENOMINATOR,
	DEFAULT_PTR_THRESHOLD};

int  _near currentMaxClients;   /* current size of clients array */
ClientPtr _near clients[MAXCLIENTS];
ClientRec _near _serverClient;
WindowPtr _near WindowTable[MAXSCREENS];

unsigned long _near globalSerialNumber = 0;
unsigned long _near serverGeneration = 0;

/* these next four are initialized in main.c */
long _near ScreenSaverTime;
long _near ScreenSaverInterval;
int  _near ScreenSaverBlanking;
int  _near ScreenSaverAllowExposures;

long _near defaultScreenSaverTime = DEFAULT_SCREEN_SAVER_TIME;
long _near defaultScreenSaverInterval = DEFAULT_SCREEN_SAVER_INTERVAL;
int  _near defaultScreenSaverBlanking = DEFAULT_SCREEN_SAVER_BLANKING;
int  _near defaultScreenSaverAllowExposure = DEFAULT_SCREEN_SAVER_EXPOSURES;
#ifndef NOLOGOHACK
int  _near logoScreenSaver = DEFAULT_LOGO_SCREEN_SAVER;
#endif

char * _near defaultFontPath = COMPILEDDEFAULTFONTPATH;
char * _near defaultTextFont = COMPILEDDEFAULTFONT;
char * _near defaultCursorFont = COMPILEDCURSORFONT;
char * _near rgbPath = NULL;
char * _near defaultDisplayClass = COMPILEDDISPLAYCLASS;
FontPtr _near defaultFont;   /* not declared in dix.h to avoid including font.h in
			every compilation of dix code */
CursorPtr _near rootCursor;
ClientPtr _near requestingClient;	/* XXX this should be obsolete now, remove? */

TimeStamp _near currentTime;

Bool _near permitOldBugs = FALSE; /* turn off some error checking, to permit certain
			     * old broken clients (like R2/R3 xterms) to work
			     */

int _near defaultColorVisualClass = -1;
int _near monitorResolution = 0;

char * _near display;

long _near TimeOutValue = DEFAULT_TIMEOUT * MILLI_PER_SECOND;
int	_near argcGlobal;
char	** _near argvGlobal;
